<template>
  <div>
    <div
      class="playTable_body-inner"
      style="opacity: 0;">
      <div
        v-for="(cell, key) in formattedGrid"
        :key="key"
        class="cell"
        @click="showBet(cell)">
        <div
          :ref="'cell'+cell.key">
        </div>
      </div>
    </div>
    <TheBetDialog
      ref="dialog"
      @confirm="createBet"
      @close="showBetDialog(false)"></TheBetDialog>
    <GameResultsDialog></GameResultsDialog>
  </div>
</template>

<script>
  import GameResultsDialog from '~/components/gameResults/';
  import notification from '~/components/UI/Notification/main.js'
  import {waitingCellStorage} from "../utils/waitingCellStorage";
  import {mapState} from 'vuex';

  export default {
    name: "grid",
    data() {
      return {
        svg: null
      }
    },
    components: {
      TheBetDialog: () => import('./TheBetDialog'),
      GameResultsDialog
    },
    computed: {
      ...mapState({
        balance: state => state.wallet.balance,
        shadowWinner: state => state.grid.shadowWin,
        isAuth: state => state.user.isAuth,
        gameStarted: state => state.game.started,
        loadingGridState: state => state.common.waiting,
        grid: state => state.grid.data,
        currentGame: state => state.game.currentGame,
        max: state => state.game.settings.cap / 24,
        step: state => state.game.settings.step,
        bet: state => state.game.betAmount,
        waitings: state => state.grid.waiting
      }),
      formattedGrid() {
        const mapper = ['x', 1, 2, 3, 4, 5, 'y', 6, 7, 8, 9, 10, 'z', 11, 12, 13, 14, 15, 0, 'a', 'b', 'c', 'd', 'e'];
        const d = [];
        for (let i = 0; i < 24; i++) {
          d.push({...this.grid[mapper[i]], ...{key: mapper[i]}});
        }
        return d;
      }
    },
    methods: {
      showBetDialog(show = true, cell = {}) {
        if (!this.balance || this.balance === 0) return notification.warning({
          message: 'Your balance is not enough',
        });
        this.$refs['dialog'].show(show, cell);
      },
      showBet(cell) {
        if (!this.isAuth) {
          this.$root.$refs['headerTop'].showAuth();
          return false;
        }
        if (!this.gameStarted || this.loadingGridState) return;
        if (!waitingCellStorage.availableForBet({
          number: cell.key,
          amount: this.bet,
          username: localStorage.getItem('accountname')
        })) return;
        if (this.grid[cell.key] && this.grid[cell.key].amount >= this.max) return false;
        this.ga(cell.key.toString().toUpperCase());
        this.showBetDialog(true, cell);
      },
      createBet({cell, amount}) {
        if (this.grid[cell.key] && this.grid[cell.key].amount >= this.max) return false;
        let my = true;
        this.$store.dispatch('game/createBet', {
          number: [cell.key],
          amount,
          my: my,
          multiplier: cell.multiplier
        }).then(res => {
          //console.log('create bet response - ', res);
        }).catch(e => {
          return notification.warning({
            message: e.message,
          });
        });
      }
    }
  }
</script>
